/*
Rewards API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package rewardsapi

import (
	"encoding/json"
	"fmt"
)

// WebhookRequest struct for WebhookRequest
type WebhookRequest struct {
	AssignCouponWebhook *AssignCouponWebhook
	ChangePointsWebhook *ChangePointsWebhook
	CreateLoyaltyWebhook *CreateLoyaltyWebhook
	RedeemCouponWebhook *RedeemCouponWebhook
}

// Unmarshal JSON data into any of the pointers in the struct
func (dst *WebhookRequest) UnmarshalJSON(data []byte) error {
	var err error
	// try to unmarshal JSON data into AssignCouponWebhook
	err = json.Unmarshal(data, &dst.AssignCouponWebhook);
	if err == nil {
		jsonAssignCouponWebhook, _ := json.Marshal(dst.AssignCouponWebhook)
		if string(jsonAssignCouponWebhook) == "{}" { // empty struct
			dst.AssignCouponWebhook = nil
		} else {
			return nil // data stored in dst.AssignCouponWebhook, return on the first match
		}
	} else {
		dst.AssignCouponWebhook = nil
	}

	// try to unmarshal JSON data into ChangePointsWebhook
	err = json.Unmarshal(data, &dst.ChangePointsWebhook);
	if err == nil {
		jsonChangePointsWebhook, _ := json.Marshal(dst.ChangePointsWebhook)
		if string(jsonChangePointsWebhook) == "{}" { // empty struct
			dst.ChangePointsWebhook = nil
		} else {
			return nil // data stored in dst.ChangePointsWebhook, return on the first match
		}
	} else {
		dst.ChangePointsWebhook = nil
	}

	// try to unmarshal JSON data into CreateLoyaltyWebhook
	err = json.Unmarshal(data, &dst.CreateLoyaltyWebhook);
	if err == nil {
		jsonCreateLoyaltyWebhook, _ := json.Marshal(dst.CreateLoyaltyWebhook)
		if string(jsonCreateLoyaltyWebhook) == "{}" { // empty struct
			dst.CreateLoyaltyWebhook = nil
		} else {
			return nil // data stored in dst.CreateLoyaltyWebhook, return on the first match
		}
	} else {
		dst.CreateLoyaltyWebhook = nil
	}

	// try to unmarshal JSON data into RedeemCouponWebhook
	err = json.Unmarshal(data, &dst.RedeemCouponWebhook);
	if err == nil {
		jsonRedeemCouponWebhook, _ := json.Marshal(dst.RedeemCouponWebhook)
		if string(jsonRedeemCouponWebhook) == "{}" { // empty struct
			dst.RedeemCouponWebhook = nil
		} else {
			return nil // data stored in dst.RedeemCouponWebhook, return on the first match
		}
	} else {
		dst.RedeemCouponWebhook = nil
	}

	return fmt.Errorf("data failed to match schemas in anyOf(WebhookRequest)")
}

// Marshal data from the first non-nil pointers in the struct to JSON
func (src *WebhookRequest) MarshalJSON() ([]byte, error) {
	if src.AssignCouponWebhook != nil {
		return json.Marshal(&src.AssignCouponWebhook)
	}

	if src.ChangePointsWebhook != nil {
		return json.Marshal(&src.ChangePointsWebhook)
	}

	if src.CreateLoyaltyWebhook != nil {
		return json.Marshal(&src.CreateLoyaltyWebhook)
	}

	if src.RedeemCouponWebhook != nil {
		return json.Marshal(&src.RedeemCouponWebhook)
	}

	return nil, nil // no data in anyOf schemas
}

type NullableWebhookRequest struct {
	value *WebhookRequest
	isSet bool
}

func (v NullableWebhookRequest) Get() *WebhookRequest {
	return v.value
}

func (v *NullableWebhookRequest) Set(val *WebhookRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableWebhookRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableWebhookRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWebhookRequest(val *WebhookRequest) *NullableWebhookRequest {
	return &NullableWebhookRequest{value: val, isSet: true}
}

func (v NullableWebhookRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWebhookRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


